/* Juan Berjillos Castellanos
   Clases001_0.cpp
   Hora/Fecha inicio: 24/10/03 12:31
   Descripcin: Intento de estudio de las clases.
*/

#include <iostream>
#include <cstring>
using namespace std;

const int LONGNOMBRE=40;  // Longitud de los nombres
const int ENTESMAXIMOS=2; // Nmero mximo de entes

class Fecha  // Clase de tratamiento de fechas
    {
    private:
    int dia,mes,anno;
    public:
    // Funciones para asignar datos
    void AsignarDia (int d) {dia=d;}
    void AsignarMes (int m) {mes=m;}
    void AsignarAnno (int a) {anno=a;}
    bool AsignarFecha (int d,int m,int a);
    // Funciones para obtener datos
    int ObtenerDia () const {return dia;}
    int ObtenerMes () const {return mes;}
    int ObtenerAnno () const {return anno;}
    void ObtenerMesLetra (int m) const;
    // Funcin para la comprobacin de datos
    bool CompruebaFecha (int dia, int mes, int anno) const;
    bool AnnoBisiesto (int anno) const;  // Necesaria para \"CompruebaFecha...\"
    };
    
class ente  // Mi primera clase, que ilusin!!!
    {
    private:
    char nombre[LONGNOMBRE];
    Fecha FechaNacimiento;
    bool sexo;  // true=masculino, false=femenino
    public:
    // Funciones para asignar datos
    void AsignarFechaNacimiento (Fecha fecha) {FechaNacimiento=fecha;}
    void AsignarNombre (char nombre2[]);
    void AsignarSexo (int sexo2);
    // Funciones para obtener datos introducidos
    void ObtenerNombre (char *) const;
    void ObtenerFechaNacimiento (int &d,int &m,int &a) const;
    bool ObtenerSexo () const {return sexo;}
    };

int main()
    {
    ente Generico[ENTESMAXIMOS];
    Fecha fecha;
    int dia,mes,anno,sexo;  // Variables de manejo (introduccin, extraccin...) de datos
    char nombre[LONGNOMBRE];  // Variables de manejo (introduccin, extraccin...) de datos
    for (int i=0;i<ENTESMAXIMOS;i++)
        {
        cout << "\n\nIntroduce el nombre: ";  // Entrada de datos
        cin.getline(nombre,LONGNOMBRE);
        Generico[i].AsignarNombre(nombre);
        cout << "\nIntroduce el da del nacimiento: ";
        cin >> dia;
        cout << "\nIntroduce el mes del nacimiento: ";
        cin >> mes;
        cout << "\nY el ao: ";
        cin >> anno;
        if (fecha.AsignarFecha(dia,mes,anno))  // Fecha vlida
            {
            do
                {
                cout << endl << "Introduce el sexo (1-Masculino/2-Femenino): ";
                cin >> sexo;
                if (sexo!=1&&sexo!=2) cout << "\nSexo invlido";
                }while (sexo!=1&&sexo!=2);
            Generico[i].AsignarFechaNacimiento(fecha);
            Generico[i].AsignarSexo(sexo);
            Generico[i].ObtenerFechaNacimiento(dia,mes,anno);
            Generico[i].ObtenerNombre(nombre);
            Generico[i].ObtenerSexo();
            cout << endl << "Fecha de nacimiento de " << nombre << " : " << dia << " de ";
            fecha.ObtenerMesLetra(mes);
            cout << " de " << anno << endl << "Sexo: ";
            if (1==sexo) cout << "Masculino";
            else cout << "Femenino";
            cin.get();
            }
        else  // Fecha invlida
            {
            cout << endl << "Fecha invlida";
            i--;
            cin.get();
            }
        }
    cin.get();
    return 0;
    }

bool Fecha::AsignarFecha(int d,int m,int a)
    {
    if(CompruebaFecha(d,m,a))  // Fecha vlida
        {
        dia=d;
        mes=m;
        anno=a;
        return true;
        }
    else return false;  // Fecha invlida
    }

void Fecha::ObtenerMesLetra (int m) const
    {
    char
Mes[][11]={"Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto",
   "Septiembre","Octubre","Noviembre","Diciembre"};
    cout << Mes[m-1];
    }

bool Fecha::CompruebaFecha(int dia,int mes,int anno) const
    {
    int DiasMes[]={31,28,31,30,31,30,31,31,30,31,30,31};  // Das de los meses del ao
    if(mes>12||mes<1) return false;  // Validacin del mes
    if(AnnoBisiesto(anno)) DiasMes[1]=29;  // Si el ao es bisiesto cambio Febrero a 29 das
    if(dia>DiasMes[mes-1]) return false;  // Validacin del da
    return true;
    }

bool Fecha::AnnoBisiesto(int anno) const
    {
    bool div=false;  // Ao no bisiesto por defecto
    if(0==anno%4) div=true;  // Condicin ao bisiesto
    if(0==anno%100) div=false;  // Condicin ao no bisiesto
    if(0==anno%400) div=true;  // Condicin ao bisiesto
    return div;
    }

void ente::AsignarNombre(char nombre2[])
    {
    strcpy(nombre,nombre2);
    }

void ente::AsignarSexo(int sexo2)
    {
    if (1==sexo2) sexo=true;
    else sexo=false;
    }

void ente::ObtenerNombre(char *pnombre2) const
    {
    strcpy(pnombre2,nombre);
    }
    
void ente::ObtenerFechaNacimiento(int &d,int &m,int &a) const
    {
    d=FechaNacimiento.ObtenerDia();
    m=FechaNacimiento.ObtenerMes();
    a=FechaNacimiento.ObtenerAnno();
    }

